unit AnalyseString;
{
FRG 26.09.97 Rvision : Ajout de commentaires
FRG 25.05.03 Ajout de la fonction SetCase (Dump ne remet plus l'option case  Insensitive)
FRG 01.06.03 Fonction format renomme pour ne pas faire de conflit avec le format Sysutils
FRG 07.06.03 Fonction Formats commentarise
FRG 07.06.03 Domaine de dfinition gr par ensemble (fonction filtre intgr  l'objet)
FRG 12.06.03 Ajout de la fonction GloupArray
FRG 08.12.03 Ajout de GloupFile
FRG 12.12.03 Ajout de SetNDef
FRG 12.12.03 Ajout de la notion de sparateur
FRG 05.02.04 Ajout de LeadingDel
}
interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls;

type     CaseOptions = (CaseSensitive,CaseInsensitive);
type     EnsembleCaractere = 0..255;
type     typeArray = array of char;

type     StringAnalyser = class
         private
         Sentence       :   TstringList;
         nullchar       :   char;
         Caseopt        :   CaseOptions;
         Domaine        :   set of EnsembleCaractere;
         Separateur     :   set of EnsembleCaractere;
         public
         constructor           create (c:char);
         destructor            destroy; override;
         procedure             free;
         procedure             SetDef(DDef:string);
         procedure             SetNDef(DDef:string);
         procedure             SetSep(DSep:string);
         function              Gloup(s:string):integer;
         function              Dump:string;
         function              Beurk:string;
         function              Permute(Modifier:StringAnalyser):integer;
         function              count:integer;
         function              LeadingAdd(s:StringAnalyser):integer;
         function              TrailingAdd(s:StringAnalyser):integer;
         function              LeadingSubtract(s:StringAnalyser):integer;
         function              TrailingSubtract(s:StringAnalyser):integer;
         function              LeadingExtract(s:StringAnalyser):StringAnalyser;
         function              TrailingExtract(s:StringAnalyser):StringAnalyser;
         function              GetIndex(s:string):integer;
         function              GetWord(index:integer):string;
         function              Extract(s:StringAnalyser):StringAnalyser;
         function              GetDDef(s:string):StringAnalyser;
         function              Dup(s:string):StringAnalyser;
         function              ProgressLeadingExtract(s:StringAnalyser):StringAnalyser;
         function              ProgressTrailingExtract(s:StringAnalyser):StringAnalyser;
         procedure             CheckDomain(s1,s2:StringAnalyser);
         function              LinkWord(mot,DefDomain2:string):integer;
         function              SplitWord(DefDomain1,DefDomain2:string):integer;
         function              Uniword(s:StringAnalyser;index:integer):boolean;
         procedure             SetCase(CaseOption:CaseOptions);
         function              Filtre(s:string):string;
         procedure             GloupArray(Buffer:TypeArray);
         procedure             GloupFile(var FileHandle:TextFile);
         procedure             LeadingDel(n:integer);
         end;

//  function Filtre             (s,list:string;nullchar:char):string;
  function fract              (s:string;c:char):string;
  function Group              (s:string;c:char):string;
//  function formats            (s,modele:string):boolean;

  const

     AccentString  : string      ='';
     NonAccentString: string     ='AAEEEUUCOAEIOU';
// Aide pour la construction des domaines
     DMajuscules   : string    ='ABCDEFGHIJKLMNOPQRSTUVWXYZ';
     DMinuscules   : string    ='abcdefghijklmnopqrstuvwxyz';
     DChiffres     : string    ='0123456789';
     DAccents      : string    ='';
     DNomFichier   : string    ='!^$#@)([]{}~%-_+.'; // caractres qui peuvent apparaitrent dans les noms de fichiers

implementation


{------------------------------------------------------------------------------
-------------------------------------------------------------------------------
Mthodes de l'objet StringAnalyser
-------------------------------------------------------------------------------
------------------------------------------------------------------------------}
constructor StringAnalyser.create (c:char);
begin
nullchar:=c;
CaseOpt:=CaseInsensitive;
Sentence:=TstringList.create;
Domaine:=[];
Separateur:=[];
end;

{------------------------------------------------------------------------------}
destructor StringAnalyser.destroy;
{------------------------------------------------------------------------------}
begin
Sentence.free;
inherited destroy;
end;

{------------------------------------------------------------------------------ }
procedure StringAnalyser.free;
{------------------------------------------------------------------------------}
begin
if self <> nil then destroy;
end;

{------------------------------------------------------------------------------
// Domaine de dfinition
{------------------------------------------------------------------------------}
Procedure StringAnalyser.SetDef(DDef:string);
var i: integer;
begin
if Sentence.count>0 then
   raise exception.create('Phrase non vide pour changement de domaine');

for i:=1 to length(Ddef) do begin
    Domaine:=Domaine+[ord(Ddef[i])];
    end;
end;

{------------------------------------------------------------------------------
// Sous ensemble de l'exclusion de domaine qui gnre un mot vide dans la phrase
// Dfinition facultative
{------------------------------------------------------------------------------}
Procedure StringAnalyser.SetSep(DSep:string);
var i: integer;
begin
if Sentence.count>0 then
   raise exception.create('Phrase non vide pour changement de critres lexicaux');

if Domaine=[] then
   raise exception.create('Dfinir un domaine avant les critres lexicaux');

for i:=1 to length(DSep) do begin
    if ord(DSep[i]) in Domaine then
        raise exception.create('Aucun sparateur ne peut faire partie du domaine de dfinition ('+DSep[i]+')')
    else
        Separateur:=Separateur+[ord(DSep[i])];
    end;
end;

{------------------------------------------------------------------------------
// Anti domaine : tous les caractres sont admis sauf ceux mentionns dans la liste
{------------------------------------------------------------------------------}
Procedure StringAnalyser.SetNDef(DDef:string);
var i: integer;
begin
if Sentence.count>0 then
   raise exception.create('Phrase non vide pour changement de domaine');

Domaine:=[0..255];
Domaine:=Domaine-[ord(nullchar)];

for i:=1 to length(Ddef) do begin
    Domaine:=Domaine-[ord(Ddef[i])];
    end;
end;

{------------------------------------------------------------------------------
// Cette fonction dcoupe la chaine en mots spars par des nullchar
// Tout caractre qui n'est pas dans le Domaine est transform en nullchar
// Si la chaine n'est pas vide elle est retourne encadre de nullchar
// Les sparateurs sont conservs
------------------------------------------------------------------------------}
function StringAnalyser.Filtre(s:string):string;
var i:integer;
    f:boolean;
    rs:string;
    cs:char;

begin
if ord(nullchar) in Domaine then
   raise exception.create('Le caractre nul ne peut faire partie du domaine de dfinition');
f:=false;

for i:=1 to length(s) do begin
    cs:=s[i];
    if (ord(cs) in Domaine) or (ord(cs) in separateur) then
       begin rs:=rs+cs; f:=False; continue; end;
    if f then continue;
    rs:=rs+nullchar;
    f:=true;
    end;

if length(rs)>0 then begin
   if rs[length(rs)]<>NULLCHAR then rs:=rs+NULLCHAR;
   if copy(rs,1,1)<>NULLCHAR then rs:=NULLCHAR+rs;
   end;
Filtre:=rs;
end;

{------------------------------------------------------------------------------
Avale une phrase (sous forme de tableau de caractres) et la digre selon les options dfinies
------------------------------------------------------------------------------}
procedure             StringAnalyser.GloupArray(Buffer:TypeArray);
var w:string;
    i,j:integer;
begin
if Sentence.count>0 then
   raise exception.create('Phrase non vide pour chargement nouvelle phrase');

   j:=1;
   setlength(w,length(buffer));
   for i:=0 to length(Buffer)-1 do begin
       if ord(Buffer[i]) in Domaine then
          w[j]:=Buffer[i]
       else
           w[j]:=nullchar;
       inc(j);
       end;

   Gloup(w);

end;

{------------------------------------------------------------------------------
Avale un fichier
------------------------------------------------------------------------------}
procedure             StringAnalyser.GloupFile(var FileHandle:TextFile);
var sw:stringanalyser;
    s:string;
begin
if Sentence.count>0 then
   raise exception.create('Phrase non vide pour chargement nouvelle phrase');

sw:=Stringanalyser.create(nullchar);
sw.domaine:=Domaine;
sw.caseopt:=caseopt;
reset(FileHandle);
if Eof(FileHandle) then
   exit;
ReadLn(FileHandle,s);

   while not eof(FileHandle) do begin
      sw.gloup(s);
      TrailingAdd(sw);
      sw.dump;
      ReadLn(FileHandle,s);
      end;

end;
{------------------------------------------------------------------------------
Avale une phrase et la digre selon les options dfinies
------------------------------------------------------------------------------}
function StringAnalyser.Gloup(s:string) : integer ;
var w,word:string;
    i,j:integer;
    sep:boolean;
begin
if Sentence.count>0 then
   raise exception.create('Phrase non vide pour chargement nouvelle phrase');

// suppression des accents si l'option CaseInsensitive est active
if Caseopt=CaseInsensitive then begin
   w:=uppercase(s);
   for i:=1 to length(w) do
    for j:=1 to length(AccentString) do
        if w[i]=AccentString[j] then
           begin w[i]:=NonAccentString[j]; break; end
   end
else
   w:=s;

w:=Filtre(w);  ///

// Intgration des mots dans la liste
// Les sparateurs forcent la cration de mots vides si ils sont rpts
// DOMAINE,,DOMAINE donne ['domaine','','domaine']
word:='';
sep:=false;
for i:=1 to length(w) do begin

    if (w[i]=nullchar) then begin
       if (length(word)>0) then begin
          Sentence.add(word);
          word:='';
          sep:=false;
          end
       end
       else
           if (ord(w[i]) in Separateur) then begin
               if (length(word)>0) or (sep) then begin
                  Sentence.add(word);
                  word:='';
                  end
           end
    else // ni null ni sparateur
        begin word:=word+w[i]; sep:=True end;
    end;

Result:=Sentence.count;
end;

{------------------------------------------------------------------------------
Retourne la phrase digre et vide le string analyser (remet les options par dfauts)
-------------------------------------------------------------------------------}
function StringAnalyser.Dump:string;
begin
result:=Beurk;
Sentence.clear;
end;

{------------------------------------------------------------------------------
Retourne la phrase digre
-------------------------------------------------------------------------------}
function StringAnalyser.Beurk:string;
var
   i:integer;
   w:string;
begin
w:=nullchar;
for i:=0 to Sentence.count-1 do
    w:=w+Sentence.strings[i]+nullchar;
result:=w;
end;

{------------------------------------------------------------------------------
Remplace les mots de la sentence par ceux de la sentence Modifier
La sentence Modifier est une liste de mots dont le premier est la rfrence
et les suivants des affinitaires. Si un mot de la phrase est un mot
affinitaire il est remplac par le mot rfrence
Les deux phrases doivent avoir le mme domaine de dfinition
-------------------------------------------------------------------------------}
function  StringAnalyser.Permute(Modifier:StringAnalyser):integer;
var i,j,k:integer;
begin
CheckDomain(self,Modifier);
k:=0;

for i:=0 to sentence.count-1 do begin
    j:=Modifier.sentence.indexof(sentence.strings[i]);
    if j > 0 then begin
       sentence.delete(i);
       Sentence.insert(i,Modifier.Sentence.strings[0]);
       inc(k);
       end;
    end;
result:=k;
end;

{------------------------------------------------------------------------------
Retourne le nombre de mots
------------------------------------------------------------------------------}
function StringAnalyser.count:integer;
begin
result:=sentence.count;
end;

{------------------------------------------------------------------------------
Place la phrase paramtre en dbut de phrase
------------------------------------------------------------------------------}
function StringAnalyser.LeadingAdd(s:StringAnalyser):integer;
var i:integer;
begin
CheckDomain(self,s);
for i:=0 to s.sentence.count-1 do
    sentence.insert(0,s.sentence.strings[i]);
result:=count;
end;

{------------------------------------------------------------------------------
Place la phrase paramtre en fin de phrase
------------------------------------------------------------------------------}
function StringAnalyser.TrailingAdd(s:StringAnalyser):integer;
var i:integer;
begin
for i:=0 to s.sentence.count-1 do
    sentence.add(s.sentence.strings[i]);
Result:=count;
end;

{------------------------------------------------------------------------------
Retourne un index sur le mot dans la phrase ou -1
------------------------------------------------------------------------------}
function  StringAnalyser.GetIndex(s:string):integer;
begin
result:= sentence.indexof(s);
end;

{------------------------------------------------------------------------------
Retourne un mot d'index donn ou null
------------------------------------------------------------------------------}
function  StringAnalyser.GetWord(index:integer):string;
begin
if index<=count then
   result:= sentence.strings[index]
else
    result:=''
end;


{------------------------------------------------------------------------------
Retourne un pointeur sur un StringAnalizer contenant la phrase
place avant celle passe en paramtre ou nil
------------------------------------------------------------------------------}
function StringAnalyser.LeadingExtract(s:StringAnalyser):StringAnalyser;
var i:integer;
    sw:StringAnalyser;
begin
sw:=nil;
i:=pos(s.beurk,beurk);
if i>0 then begin
   sw:=StringAnalyser.create(nullchar);
   sw.Domaine:=self.Domaine;
   sw.gloup(copy(beurk,1,i-1));
   end;

Result:=sw;
end;


{------------------------------------------------------------------------------
Retourne un pointeur sur un StringAnalyser contenant la phrase
place APRES celle passe en paramtre ou nil
Fonction  tester : introduction de la gestion des domaines par ensembles 07.06.03
------------------------------------------------------------------------------}
function StringAnalyser.TrailingExtract(s:StringAnalyser):StringAnalyser;
var i:integer;
    sw:StringAnalyser;
begin
sw:=nil;
i:=pos(s.beurk,beurk);
if i>0 then begin
   sw:=StringAnalyser.create(nullchar);
   sw.Domaine:=self.Domaine;
   sw.gloup(copy(beurk,i+length(s.beurk),length(beurk)-length(s.beurk)-i));
   end;

Result:=sw;
end;

{------------------------------------------------------------------------------
Retourne un pointeur sur un StringAnalizer contenant la phrase
place avant celle passe en paramtre ou nil
La phrase passe en paramtre est teste en entier puis sans le dernier mot
et ainsi de suite jusqu' un seul mot
Fonction  tester : introduction de la gestion des domaines par ensembles 07.06.03
------------------------------------------------------------------------------}
function StringAnalyser.ProgressLeadingExtract(s:StringAnalyser):StringAnalyser;
var i:integer;
    sw:StringAnalyser;
    sr:StringAnalyser;
begin
sw:=nil;
sr:=s.dup(s.beurk);
i:=0;
while sr.count>0 do begin
    i:=pos(sr.beurk,beurk);
    if i>0 then break;
    sr.sentence.delete(sr.count-1)
    end;

if i>0 then begin
   sw:=StringAnalyser.create(nullchar);
   sw.Domaine:=self.Domaine;
   sw.gloup(copy(beurk,1,i-1));
   end;

sr.destroy;
Result:=sw;
end;


{------------------------------------------------------------------------------
Retourne un pointeur sur un StringAnalyser contenant la phrase
place APRES celle passe en paramtre ou nil
La phrase passe en paramtre est teste en entier puis sans le dernier mot
et ainsi de suite jusqu' un seul mot
Fonction  tester : introduction de la gestion des domaines par ensembles 07.06.03
------------------------------------------------------------------------------}
function StringAnalyser.ProgressTrailingExtract(s:StringAnalyser):StringAnalyser;
var i:integer;
    sw:StringAnalyser;
    sr:StringAnalyser;
begin
sw:=nil;
sr:=s.dup(s.beurk);
i:=0;

while sr.count>0 do begin
    i:=pos(sr.beurk,beurk);
    if i>0 then break;
    sr.sentence.delete(sr.count-1)
    end;

if i>0 then begin
   sw:=StringAnalyser.create(nullchar);
   sw.Domaine:=self.Domaine;
   sw.gloup(copy(beurk,i+length(sr.beurk),length(beurk)-length(sr.beurk)-i));
   end;
sr.destroy;
Result:=sw;
end;

{------------------------------------------------------------------------------
Retourne un pointeur sur un StringAnalyser qui ne contient que les mots
de la phrase passe en paramtre
Fonction  tester : introduction de la gestion des domaines par ensembles 07.06.03
------------------------------------------------------------------------------}

function  StringAnalyser.Extract(s:StringAnalyser):StringAnalyser;
var i:integer;
    sw:StringAnalyser;
begin
   sw:=StringAnalyser.create(nullchar);
   sw.Domaine:=self.domaine;
   for i:=0 to count-1 do
       if s.sentence.indexof(sentence.strings[i])>-1 then
          sw.sentence.add(sentence.strings[i]);;
result:=sw;
end;

{------------------------------------------------------------------------------
Retourne un pointeur sur un StringAnalyser contenant les mots de la phrase
qui sont conforme au domaine de dfinition pass en paramtre
------------------------------------------------------------------------------}
function StringAnalyser.GetDDef(s:string):StringAnalyser;
var i:integer;
    sw,sr:StringAnalyser;
begin
   sw:=StringAnalyser.create(nullchar);
   sw.setDef(s);
   sr:=StringAnalyser.create(nullchar);
   sr.setDef(s);

   for i:=0 to count-1 do begin
       sw.gloup(sentence.strings[i]);
       sr.trailingAdd(sw);
       sw.dump;
       end;
sw.destroy;
result:=sr;
end;


{-------------------------------------------------------------------------------
Cre une copie de la phrase en cours avec le texte pass en paramtre
Fonction  tester : introduction de la gestion des domaines par ensembles 07.06.03
--------------------------------------------------------------------------------}
function StringAnalyser.Dup(s:string):StringAnalyser;
var sw:StringAnalyser;
begin
     sw:=Stringanalyser.create(nullchar);
     sw.Domaine:=Domaine;
     sw.gloup(s);
     result:=sw;
end;


{-------------------------------------------------------------------------------
Supprime la phrase s de la phrase courante si elle se trouveau dbut
--------------------------------------------------------------------------------}
function    StringAnalyser.LeadingSubtract(s:StringAnalyser):integer;
var sw:StringAnalyser;
    nword:integer;
begin
nword:=count;
Result:=0;
if (s.count>0) then begin
    sw:=TrailingExtract(s);
    if sw = nil then exit;
    dump;
    gloup(sw.beurk);
    sw.destroy;
    end;
result:=nword-count;
end;

{-------------------------------------------------------------------------------
Supprime la phrase s de la phrase courante si elle se trouve  la fin
--------------------------------------------------------------------------------}
function    StringAnalyser.TrailingSubtract(s:StringAnalyser):integer;
var sw:StringAnalyser;
    nword:integer;
begin
nword:=count;
Result:=0;
if s.count > 0 then begin
    sw:=LeadingExtract(s);
    if sw = nil then exit;
    dump;
    gloup(sw.beurk);
    sw.destroy;
    end;
result:=nword-count;
end;

{-------------------------------------------------------------------------------
Produit une exception si les domaines sont diffnents
--------------------------------------------------------------------------------}
procedure StringAnalyser.CheckDomain(s1,s2:StringAnalyser);
begin
{if s1.DefDomain<>s2.DefDomain then
   raise exception.create('Permutation impossible si domaine diffrents');
   }
if s1.domaine * s2.domaine <> s1.domaine then
   raise exception.create('Permutation impossible si domaine diffrents');
end;

{-------------------------------------------------------------------------------
Si le mot pass en paramtre est dans la phrase et que le mot suivant est dans le
domaine pass en paramtre, les deux mots sont groups.
--------------------------------------------------------------------------------}
function StringAnalyser.LinkWord(mot,DefDomain2:string):integer;
var s1:StringAnalyser;
    i:integer;
begin
s1:=GetDdef(DefDomain2);
s1.dump;

i:=GetIndex(mot);                           // chercher le mot
if (i>-1) and (i < count) then begin
   s1.gloup(sentence.strings[i+1]);         // le mot suivant est-il dans le domaine
   if s1.count=1 then UniWord(self,i);      // grouper les mots
   end;

s1.destroy;
result:=count;
end;

function    StringAnalyser.Uniword(s:StringAnalyser;index:integer):boolean;
begin
result:=false;
if index+1>s.count then exit;
s.sentence.strings[index]:=s.sentence.strings[index]+s.Sentence.strings[index+1];
s.Sentence.delete(index+1);
Result:=True;
end;

{-------------------------------------------------------------------------------
Spare en deux mots les mots qui appartiennent respectivement aux domaines
pass en paramtre. Exemple 2BIS devient 2.BIS avec les domaines '2' et 'BIS'
Fonction  tester s2.destroy dplac le 7.6.3
--------------------------------------------------------------------------------}

function      StringAnalyser.SplitWord(DefDomain1,DefDomain2:string):integer;
var s1,s2,s3,s4,s5:StringAnalyser;
    i,j:integer;
begin
s1:=GetDdef(DefDomain1+DefDomain2);
if s1.count > 0 then begin
   s2:=s1.dup('');
   for i:=0 to s1.count-1 do begin
       s2.dump;
       s2.gloup(fract(s1.Getword(i),nullchar));
       s3:=s2.GetdDef(DefDomain1);
       s4:=s2.GetdDef(DefDomain2);
       if (s3.count=0) or (s4.count=0) then begin
          s3.destroy;
          s4.destroy;
          continue;
          end;
       s5:=s3.dup(s3.beurk);
       s5.TrailingAdd(s4);  // s5=s3+s4
       if s5.beurk=s2.beurk then begin
          j:=GetIndex(s1.sentence.strings[i]);
          sentence.delete(j);
          sentence.insert(j,Group(s4.beurk,nullchar));
          sentence.insert(j,Group(s3.beurk,nullchar));
          end;
       s3.destroy;
       s4.destroy;
       s5.destroy;
       end;
   s2.destroy;
   end;
s1.destroy;
result:=count;
end;


{-------------------------------------------------------------------------------
 Spcifie l'option de casse
-------------------------------------------------------------------------------}

procedure          StringAnalyser.SetCase(CaseOption:CaseOptions);
begin
if count>0 then
   raise exception.create('L''option de casse ne peut se changer que dans une phrase vide');
caseopt:=caseoption;
end;

{-------------------------------------------------------------------------------
Supprime n mots au dbut de la phrase
--------------------------------------------------------------------------------}
procedure    StringAnalyser.LeadingDel(n:integer);
var i:integer;
begin
for i:=0 to n-1 do
    Self.Sentence.delete(0);
end;
{-------------------------------------------------------------------------------
 Fonctions et procdures non attaches  l'objet Stringanalyser
-------------------------------------------------------------------------------}

{-------------------------------------------------------------------------------
 Fractionne la chaine s en placant un nullchar entre chaque lettre
-------------------------------------------------------------------------------}
function fract (s:string;c:char):string;
var i:integer;
begin
     Result:='';
     for i:=1 to length(s) do begin
         result:=result+c+copy(s,i,1)+c;
         end;
end;

{-------------------------------------------------------------------------------
Elimine tous les nullchar et regroupe les mots en un seul
-------------------------------------------------------------------------------}
function Group (s:string;c:char):string;
var i:integer;
    x:char;
begin
     Result:='';
     for i:=1 to length(s) do begin
         x:=s[i];
         if x <> c then
            Result:=Result+x;
         end;
end;


{-------------------------------------------------------------------------------
 Filtre la chaine s en fonction du jeu de caractre List et renvoie une chaine
ou tous les caractres de s qui ne sont pas dans List sont remplacs par des
nullchar unique
-------------------------------------------------------------------------------}
{
function Filtre(s,List:string;nullchar:char):string;
var i:integer;
    f:boolean;
    rs:string;
    cs:string;
begin
if pos(nullchar,List) > 0 then
   raise exception.create('Le caractre nul ne peut faire partie du domaine de dfinition');
f:=false;

for i:=1 to length(s) do begin
    cs:=copy(s,i,1);
    if pos(cs,List)>0
       then begin rs:=rs+cs; f:=False; continue; end;
    if f then continue;
    rs:=rs+nullchar;
    f:=true;
    end;

if length(rs)>0 then begin
   if rs[length(rs)]<>NULLCHAR then rs:=rs+NULLCHAR;
   if copy(rs,1,1)<>NULLCHAR then rs:=NULLCHAR+rs;
   end;
Filtre:=rs;
end;
}

{-------------------------------------------------------------------------------
Dtermine la compatibilit de la chaine avec le format pass en paramtre
-------------------------------------------------------------------------------}
{ fonction non stabilise
function   formats(s,modele:string):boolean;
var i,j:integer;
begin

for i:=1 to length(s) do
    begin
        if i>length(modele) then begin result:=false; exit; end;
        case modele[i] of
             '9' : if (s[i] < '0') or (s[i] > '9') then begin result:= false; exit; end;
             'A' : if (s[i] < 'A') or (s[i] > 'Z') then begin result:= false; exit; end;
             '*' : continue;
        else if (s[i] <> modele[i]) then begin result:=false; exit; end;
        end;
    end;
j:=i;
for i:=j to length(modele) do
    if modele[i]<> '*' then begin result:=false; exit; end;
end;
}
end.


{
{-------------------------------------------------------------------------------
Concatene les mots successifs qui appartiennent  deux domaines
si mot(n) est dans d1 et que mot (n+1) est dans d2 alors mot(n) devient mot(n)+mot(n+1)
Par exemple 'CEDEX 17' devient 'CEDEX17' avec des domaines ALPHA et NUM
mais '12 RUE' ne change pas car l'ordre d'appartenance des domaines est invers
--------------------------------------------------------------------------------}
Ancienne version de Linkword :

function StringAnalyser.LinkWord(DefDomain1,DefDomain2:string):integer;
var s1,s2:StringAnalyser;
    i,j,x1,x2:integer;
begin
s1:=GetDdef(DefDomain1);
s2:=GetDdef(DefDomain2);
for i:=0 to s1.count-1 do
    for j:=0 to s2.count-1 do begin
        x1:=GetIndex(s1.Getword(i));
        x2:=GetIndex(s2.GetWord(j));
        if x1+1=x2 then begin
           Sentence.strings[x1]:=Sentence.strings[x1]+Sentence.strings[x2];
           Sentence.delete(x2);
           end;
        end;
s1.destroy;
s2.destroy;
result:=count;
end;
 }


