unit LegendFinder;
{
L'unit LegenFinder contient des outils permettant de rechercher un mot dans un fichier
et de retourner le texte qui suit ce mot jusqu'au prochain retour chariot (caratre 0x0D).

Pour les besoins de l'application gnalogie certaines rgles spcifiques sont appliques :

Rgle 1 les mots recherchs sont des noms de fichier. L'extension du fichier est te avant la recherche.
Si on cherche A14.jpg on lira "A14".

Rgle 2 les mots doivent tre suivis de espace et deux points.
Si on cherche A14.JPG on lira "A14 :"
}

interface

uses sysutils,classes,analysestring,dialogs,FileCtrl;

procedure     ReadFilename(filename:string);
procedure     ReadDirectory(Path:string; var List:TstringList);
function      GetTitle(imagename:string):string;
function      GetWord(imagename:string;pos1,pos2,len:integer; OneBuffer : TypeArray):string;

var
Lbuffer : array of TypeArray;


implementation

//            Recherche tous les fichiers du rpertoire path et les passe  ReadFileName
procedure     ReadDirectory(Path:string; var List:TstringList);
var Sr:TSearchRec;
    Drive:char;
    Dir,Filename:string;
    i:integer;
begin

// etablir la liste des fichiers et la ranger en table srt
if findfirst(Path,FaAnyFile,Sr)=0 then     begin
       repeat
       ProcessPath(Path,Drive,Dir,Filename);
       ReadFileName(Drive+':\'+Dir+'\'+sr.name);
       List.add(Drive+':\'+Dir+'\'+sr.name);
       until findnext(Sr)<>0;
       Findclose(Sr);
    end;
end;


// Lit les fichiers et les range dans LBuffer
procedure ReadFilename(filename:string);
var f:file;
    recsize,i,j,got:integer;
    FileModeSave:byte; //Version 1.55
begin

     if filename='' then exit;
     if not Fileexists(filename) then exit;

     FileModeSave:=FileMode;

     i:=length(LBuffer);
     Setlength(LBuffer,i+1);

     {$I-}
     FileMode:=0; //Version 1.55
     AssignFile(F,Filename);
     if IoResult<>0 then begin fileMode:=FileModeSave; exit; end;
     Reset(F,1);
     if IoResult<>0 then begin fileMode:=FileModeSave; exit; end;
     {$I+}

     RecSize:=FileSize(F);
     SetLength(lBuffer[i],RecSize+1);

     Reset(F);

     j:=0;
     repeat begin
          BlockRead(F,LBuffer[i,j],1,got);
          inc(j,128);
          end;
          until got<1;

     closeFile(F);
     LBuffer[i][Recsize]:=#255; // marque de fin
     FileMode:=FileModeSave;

end;


function GetTitle(imagename:string):string;
var p,i:integer;
begin

Result:='';

if length(Lbuffer)=0 then exit;

ImageName:=ExtractFileName(ImageName);

p:=pos('.',imagename);                       // Rgle 2
if p>0 then
   delete(imagename,p,length(imagename)-p+1);

imagename:=chr($d)+imagename;                   // Rgle 2

for i:=0 to length(LBuffer)-1 do begin

    if length(lbuffer[i])=0 then exit;

    Result:=GetWord(imagename,0,1,length(imagename),LBuffer[i]);
    if Result<>'' then break;
    end;

end;


function  GetWord(imagename:string;pos1,pos2,len:integer; OneBuffer : TypeArray):string;
var s:string;
    i:integer;
begin

for i:=0 to length(Onebuffer)-1 do begin
    if pos2>len then break;
    if uppercase(Onebuffer[pos1])=uppercase(copy(imagename,pos2,1)) then begin
       inc(pos2);
       end
    else while (pos2>1) do begin dec(pos2); dec(pos1); end;
    inc(pos1);
    end;

if pos2>len then begin
   i:=pos1-len+1;     // + 1 car le premier caractre est un retour chariot
   while Onebuffer[i]<>#13 do begin
         s:=s+Onebuffer[i];
         inc(i);
         end;
   end;

result:=s;
end;

end.
